#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

int main(argc, argv, envp)
	int argc;
	char **argv[];
	char **envp[];
{
	time_t curtime=0;
	int stringlen=0;
	int daemonize=0;
	int forky=0;
	int help=0;
	int wholeline=0;
	FILE *filehan=NULL;
	FILE *ttyout=NULL;
	FILE *logfile=NULL;
	char *logfilename=NULL;
	char *filename=NULL;
	char *ttyfilename=NULL;
	char *string=NULL;
	char *inputstring=NULL;
	char argy=(char)0;

	inputstring=(char *)calloc(1,4096);

	filehan=(FILE *)malloc(sizeof(FILE));
	ttyout=(FILE *)malloc(sizeof(FILE));

	do
	{
		argy = getopt(argc,(char **)argv,"h?dt:f:l:s:w");
		switch (argy)
		{
			case 'h':	help=1;
					break;
			case '?':	help=1;
					break;
			case 'd':	daemonize=1;
					break;
			case 'l':	logfilename=(char *)calloc(1,1024);
					strcpy(logfilename,optarg);
					break;
			case 'w':	wholeline=1;
					break;
			case 't':	ttyfilename=(char *)calloc(1,1024);
					strcpy(ttyfilename,optarg);
					break;
			case 'f':	filename=(char *)calloc(1,1024);
					strcpy(filename,optarg);
					break;
			case 's':	string=(char *)calloc(1,1024);
					strcpy(string,optarg);
					stringlen=strlen(string);
					break;
			default: ;
		}
	} while (argy != EOF);

	if (help==1)
	{
		printf("\nUsage: %s -f (filename) -t (tty) -s (string) [-d]\n",(char *)argv[0]);
		printf("\n");
		printf("-l filename   append to log file.\n");
		printf("-w            show whole line in log file. (-l required)\n");
		printf("-f filename   filename is the file to watch.\n");
		printf("-t /dev/ttyxx tty to send the beeps to.\n");
		printf("-s string     string to watch for in filename.\n");
		printf("-d            daemonize.\n");
		printf("\n");
		exit(0);
	}

	if (daemonize==1)
	{
		forky=fork();

		if (forky>0) {
			printf ("Forked!\n");
			exit(0);
		}
		else if (forky<0)
		{
			printf ("fork failed.\n");
			exit(1);
		}
	}

	if ((filename==NULL) || (string==NULL) || (ttyfilename==NULL))
	{
		printf ("You MUST specify at least -t, -f and -s!\n");
		exit(1);
	}

	if ((filehan=fopen(filename,"r"))==NULL)
	{
		printf ("Can't open %s!\n",filename);
		exit(2);
	}

	if ((fseek(filehan,0L,SEEK_END))!=0)
	{
		printf ("Can't seek to end of file %s!\n",filename);
		exit(2);
	}

	if ((ttyout=fopen(ttyfilename,"a+"))==NULL)
	{
		printf ("Can't open %s!\n",ttyfilename);
		exit(2);
	}

	if (logfilename!=NULL)
	{
		if ((logfile=fopen(logfilename,"a+"))!=(FILE *)NULL)
		{
			fprintf(logfile,"Program started...\n");
			fflush(logfile);
		} else
		{
			printf ("Can't open log file %s\n",logfilename);
			exit (1);
		}
	} else {
	if (wholeline==1)
		printf ("Ignoring -w because -l not specified.\n");
	}
	
	for (;;)
	{
		memset(inputstring,0,4096);
		fgets(inputstring,1024,filehan);
		if (strstr(inputstring,string)!=NULL)
		{
			curtime=time(NULL);
			if (logfilename!=(char *)NULL)
			{
				if (wholeline==1)
				{
				fprintf(logfile,"%s -> %s",
					inputstring, ctime(&curtime));
				} else {
				fprintf(logfile,"Saw \"%s\" in %s at %s",
					string, filename, ctime(&curtime));
				}
				fflush(logfile);
			}
			fprintf(ttyout,"%c",7);
			fflush(ttyout);
		}
	}
}
